// $Id: TclInterp.h,v 1.5 2001/11/07 18:00:23 cthuang Exp $
#ifndef TCLINTERP_H
#define TCLINTERP_H

#include <string>
#include <comdef.h>
#include <tcl.h>

// This class provides access to a Tcl interpreter loaded from a DLL.

class TclInterp
{
    std::string m_rootDir;
    HINSTANCE m_hmodTcl;
    Tcl_Interp *m_interp;

    // Do not allow others to copy instances of this class.
    TclInterp(const TclInterp &);       // not implemented
    void operator=(const TclInterp &);  // not implemented

    // Load and initialize interpreter.
    void doInitialize(const std::string &dllPath);

public:
    TclInterp();
    ~TclInterp();

    // Load and initialize interpreter.
    void initialize(const std::string &dllPath);

    // Get directory where Tcl run-time is installed.
    const std::string &rootDir () const
    { return m_rootDir; }

    // Get Tcl interpreter.
    operator Tcl_Interp * ()
    { return m_interp; }
};

#endif
