// $Id: TclModule.cpp,v 1.2 2001/11/07 18:00:23 cthuang Exp $
#pragma warning(disable: 4786)
#include "TclModule.h"
#include "RegistryKey.h"

int
TclModule::registerFactoryByScript (const std::string &clsid)
{
    // Get registry key containing initialization data.
    std::string subkeyName("CLSID\\");
    subkeyName += clsid;
    subkeyName += "\\tcom";
    RegistryKey extensionKey(HKEY_CLASSES_ROOT, subkeyName);

    // Initialize Tcl interpreter.
    m_interp.initialize(extensionKey.value("TclDLL"));

    // Execute Tcl script which should register a class factory.
    std::string script = extensionKey.value("Script");
    return Tcl_EvalEx(
        m_interp,
        const_cast<char *>(script.data()),
        script.size(),
        TCL_EVAL_GLOBAL);
}
