// $Id: dllmain.cpp,v 1.10 2001/11/28 16:10:58 cthuang Exp $
#pragma warning(disable: 4786)
#include "Uuid.h"
#include "TclModule.h"
#include "TclInterp.h"

// This class implements a COM module for DLL-based servers.

class DllModule: public TclModule
{
public:
    DllModule ()
    { }
};

static DllModule module;


STDAPI
DllCanUnloadNow () 
{
    return (module.lockCount() == 0) ? S_OK : S_FALSE;
}

STDAPI
DllGetClassObject (REFCLSID clsid, REFIID iid, void **ppv)
{
    try {
        // Use CLSID to find initialize script from registry.
        std::string clsidStr("{");
        Uuid uuid(clsid);
        clsidStr += uuid.toString();
        clsidStr += "}";

        int completionCode = module.registerFactoryByScript(clsidStr);
        if (completionCode != TCL_OK) {
            *ppv = 0; 
            return E_UNEXPECTED;
        }

        IClassFactory *pFactory = module.find(clsid);
        if (pFactory == 0) {
            *ppv = 0; 
            return CLASS_E_CLASSNOTAVAILABLE;
        }
        return pFactory->QueryInterface(iid, ppv);
    }
    catch (...) {
        *ppv = 0; 
        return CLASS_E_CLASSNOTAVAILABLE;
    }
}
